package agiledeveloper.pricing;

import agiledeveloper.bid.Bid;
import agiledeveloper.sellers.*;

public class Pricing {                          
  public Bid getBestBid(int maxPrice) {
    Seller1 seller1 = new Seller1();
    int priceSeller1 = seller1.getPrice();

    Seller2 seller2 = new Seller2();
    int priceSeller2 = seller2.getPrice();

    Seller3 seller3 = new Seller3();
    int priceSeller3 = seller3.getPrice();
    
    int bestPrice = priceSeller1;
    String bestBidder = seller1.getName();
    
    if(priceSeller2 < bestPrice) {
      bestPrice = priceSeller2;
      bestBidder = seller2.getName();
    }

    if(priceSeller3 < bestPrice) {
      bestPrice = priceSeller3;
      bestBidder = seller3.getName();
    }                     
    
    if(bestPrice <= maxPrice) {
      return new Bid(bestBidder, bestPrice);
    } else {
      return null;
    }
  }
  
  public static void main(String[] args) {
    Pricing pricing = new Pricing();
                                                      
    int amount = 200;
    Bid bestBid = pricing.getBestBid(amount);
                                          
    System.out.println("The best bid for price under $" + amount + " is:");
    
    if(bestBid != null) {
      System.out.print("Seller: " + bestBid.getBidder());
      System.out.println(" Price: $" + bestBid.getPrice());      
    } else {
      System.out.println("Sorry, no bid found for that price");
    }
  }
}
